local waitTable = {};
local waitFrame = nil;

-- functions
local debug = true;
function cui_debug(...)
    if (not debug) then
        return;
    end

    local message = "";

    for i = 1, select("#", ...) do
		message = message .. " " .. messageString(select(i, ...));
	end

    DEFAULT_CHAT_FRAME:AddMessage("CUI >> "..(message or "nil"), 1.0, 1.0, 1.0, 1, 10);

    
end

function messageString(value)
    if (type(value) == "boolean") then
        if (value) then
            return "true";
        else
            return "false";
        end
    end

    if (type(value) == "function") then
        return "fn";
    end

    if (type(value) == "table") then
        local result = ""
        for key, val in pairs(value) do
            result = result..";"..key..":"..messageString(val);
        end
        return result..";";
    end

    return value or "nil";
end

-- functions
function cui_info(value, name)
    if (name) then
        DEFAULT_CHAT_FRAME:AddMessage("|c222266ff"..name.."|r    "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    else
        DEFAULT_CHAT_FRAME:AddMessage("|c333399ffCleanUI|r    "..(value or "nil"), 1.0, 1.0, 1.0, 1, 10);
    end
end

function CleanUI_StartDelay(delay, func, ...)
    if(type(delay)~="number" or type(func)~="function") then
        return false;
    end

    if (delay == 0) then
        func();
        return;
    end

    if(waitFrame == nil) then
        waitFrame = CreateFrame("Frame","CUI_WaitFrame", UIParent);
        waitFrame:SetScript("onUpdate",function (self,elapse)
            local count = #waitTable;
            local i = 1;

            while(i<=count) do
                local waitRecord = tremove(waitTable,i);
                local d = tremove(waitRecord,1);
                local f = tremove(waitRecord,1);
                local p = tremove(waitRecord,1);

                if(d>elapse) then
                    tinsert(waitTable,i,{d-elapse,f,p});
                    i = i + 1;
                else
                    count = count - 1;
                    f(unpack(p));
                end
            end
        end);
    end

    tinsert(waitTable,{delay,func,{...}});

    return true;
end

function CleanUI_GetClassColor(unit)
    local classColor = { r = 1.0, g = 1.0, b = 1.0, colorStr = "ffffffff" };

    if (unit) then
        local localizedClass, englishClass = UnitClass(unit);
        classColor = RAID_CLASS_COLORS[englishClass];

        if (not classColor) then
            classColor = { r = 1.0, g = 1.0, b = 1.0, colorStr = "ffffffff" };
        end
    end

    return classColor;
end