function CleanUI_InitDataStore()
    CleanUI_InitDataStoreCollector()

    CleanUI_AddMoneyTooltip();
end

function CleanUI_DataStoreSlashCommandHandler(msg)
    if (msg == "reset money") then
        CleanUI_ResetMoney();
    else
        return false;
    end

    return true;
end

function CleanUI_AddMoneyTooltip()  
    ContainerFrame1MoneyFrameGoldButton:HookScript("OnEnter", CleanUI_ShowMoneyFrameTooltip);
    ContainerFrame1MoneyFrameGoldButton:HookScript("OnLeave", CleanUI_HideMoneyFrameTooltip);      
    ContainerFrame1MoneyFrameSilverButton:HookScript("OnEnter", CleanUI_ShowMoneyFrameTooltip);
    ContainerFrame1MoneyFrameSilverButton:HookScript("OnLeave", CleanUI_HideMoneyFrameTooltip);  
    ContainerFrame1MoneyFrameCopperButton:HookScript("OnEnter", CleanUI_ShowMoneyFrameTooltip);
    ContainerFrame1MoneyFrameCopperButton:HookScript("OnLeave", CleanUI_HideMoneyFrameTooltip);
end

function CleanUI_ShowMoneyFrameTooltip(self)
    local playerFaction, localizedFaction = UnitFactionGroup("player");
    
    GameTooltip_SetDefaultAnchor(GameTooltip, self);
    
    local data = CleanUIDataStore["money"] or {};
    
    local summe = 0;
    local name, moneyString;

    local account = CleanUIDataStore["account"];

    GameTooltip:AddLine(MONEY);
    
    for guid, amount in pairs(data) do
        if (playerFaction == account[guid].faction) then
            summe = summe + amount;
            name = "|c333399ff"..account[guid].name.."|r";
            moneyString = "|cffffffff"..GetCoinTextureString(amount).."|r";
            GameTooltip:AddDoubleLine(name, moneyString);
        end
    end
    
    GameTooltip:AddLine(" ");
    GameTooltip:AddDoubleLine("|c333399ff"..localizedFaction.."|r", "|cffffffff"..GetCoinTextureString(summe).."|r");

    GameTooltip:Show();
end

function CleanUI_HideMoneyFrameTooltip()
    GameTooltip:FadeOut();
end

