-- temporary data
local item_profit = 0;

function CleanUI_InitMerchant()
    CleanUI_RegisterMerchantEvents();

    -- Display the amount of copper that is added to the tooltip
    GameTooltip:HookScript("OnTooltipAddMoney",
        function(self, amount)
            item_profit = amount;
        end);
end

function CleanUI_RegisterMerchantEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("MERCHANT_SHOW");
    
    frame:HookScript("OnEvent", CleanUI_MerchantOnEvent);
end

function CleanUI_MerchantOnEvent(self, event, ...)
    if (event == "MERCHANT_SHOW") then
        CleanUI_MerchantShow();
    end
end

function CleanUI_MerchantShow()

    -- auto repair
    if (not IsControlKeyDown() and CanMerchantRepair()) then
        repairAllCost, canRepair = GetRepairAllCost();

        if (IsAltKeyDown()) then
            RepairAllItems(1);      -- guild
        else
            RepairAllItems();
        end
        
        PlaySound(SOUNDKIT.ITEM_REPAIR);

        if (repairAllCost > 0) then
            DEFAULT_CHAT_FRAME:AddMessage(REPAIR_COST.." "..GetCoinTextureString(repairAllCost), 1.0, 1.0, 0, 1, 10);
        end
    end

    local sum_item_profit = 0

    local container, numberOfSlots;
    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture;
    for id = 0, 4, 1 do
        container = _G["ContainerFrame"..(id + 1)];

        if (container) then
            numberOfSlots = GetContainerNumSlots(id);

            for slot=1, numberOfSlots, 1 do
                itemLink = GetContainerItemLink(id, numberOfSlots - slot + 1);

                if (itemLink) then
                    itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(itemLink);

                    if (itemRarity == 0) then
                        GameTooltip:SetBagItem(id, numberOfSlots - slot + 1);

                        if (item_profit and item_profit > 0) then
                            sum_item_profit = sum_item_profit + item_profit;
                            DEFAULT_CHAT_FRAME:AddMessage(ITEM_SOLD_COLON.." "..itemLink.. " ("..GetCoinTextureString(item_profit)..")", 1.0, 1.0, 0, 1, 10);
                            UseContainerItem(id, numberOfSlots - slot + 1);
                        end
                    end
                end
            end
        end
    end

    if (sum_item_profit > 0) then
        DEFAULT_CHAT_FRAME:AddMessage(" ==> "..GetCoinTextureString(sum_item_profit), 1.0, 1.0, 0, 1, 10);
    end
end
