function CleanUI_InitTweaks()
    CleanUIUserData = CleanUIUserData or {};

    CleanUIUserData.UnitFrameScale = CleanUIUserData.UnitFrameScale or 1.0;

    CleanUI_RegisterTweaksEvents();

    CleanUI_InstallTweaks();

    -- flash Mac-OSX Dock icon or Windows-Taskbar icon
    hooksecurefunc("StaticPopup_Show", FlashClientIcon);
end

function CleanUI_RegisterTweaksEvents()
    local frame = CreateFrame("Frame");

    frame:RegisterEvent("ADDON_LOADED");
    frame:RegisterEvent("READY_CHECK");

    frame:HookScript("OnEvent", CleanUI_TweaksOnEvent);
end

function CleanUI_TweaksOnEvent(self, event, ...)
    if (event == "ADDON_LOADED") then
        local addonName = ...;
        -- cui_debug("loaded", addonName);
    elseif (event == "READY_CHECK") then
        FlashClientIcon();
    end
end

function CleanUI_TweaksSlashCommandHandler(msg)
    if (string.find(msg, "scale unitframes ") == 1) then 
        local str_scale = string.sub(msg, 17);
        local scale = tonumber(str_scale);

        if (scale and scale >= 0.5 and scale <= 2.0) then
            CleanUIUserData.UnitFrameScale = scale;
            CleanUI_Tweaks_ScaleUnitFrames();
        else
            mw_info("|c333399ffscale|r: 0.5 - 2.0");
        end
    else
        return false;
    end

    return true;
end

function CleanUI_InstallTweaks()
    CleanUI_Tweaks_ScaleUnitFrames();
end

function CleanUI_Tweaks_ScaleUnitFrames()
    PlayerFrame:SetScale(CleanUIUserData.UnitFrameScale);
    TargetFrame:SetScale(CleanUIUserData.UnitFrameScale);
end
    